package me.Demon.DemonPay.util.database;

import me.Demon.DemonPay.Main;
import me.Demon.DemonPay.PLimitData;
import me.Demon.DemonPay.util.SqlUtil;
import org.bukkit.entity.Player;

import java.sql.ResultSet;
import java.util.Date;
import java.util.List;

public class SqlManager {

    private Main plugin;

    public String table = "demonpay_points";

    public SqlManager(Main plugin) {
        this.plugin = plugin;
    }

    private SqlUtil getSQL() {
        return plugin.getSqlUtil();
    }

    // 创建数据库表格格式
    public void createTable() {
        // 数据库结构组成
        // 玩家名(VARCHAR)
        // UUID(VARCHAR)
        // 已转账金额(VARCHAR)
        // 刷新时间(VARCHAR)
        String s = "CREATE TABLE IF NOT EXISTS " + table + "(" +
                "    `name` VARCHAR(64) NOT NULL," +
                "    `uuid` VARCHAR(64) NOT NULL," +
                "    `limit` VARCHAR(16) NOT NULL," +
                "    `date` VARCHAR(10) NOT NULL" +
                ") ENGINE = InnoDB";
        getSQL().openConnection();
        getSQL().updateSQL(s);
        getSQL().closeConnection();
    }

    // 创建玩家数据表格
    public void createPlayerTableData(Player p) {
        String set = "INSERT INTO " + table + " (`name`, `uuid`, `limit`, `date`) VALUES ('%name%','%uuid%','%limit%','%date%')";
        getSQL().openConnection();
        Date date = new Date();
        getSQL().updateSQL(set.replace("%name%", p.getName())
                .replace("%uuid%", String.valueOf(p.getUniqueId()))
                .replace("%limit%", "0")
                .replace("%updata%", date.getMonth() + "." + date.getDate()));
        getSQL().closeConnection();
    }

    // 从数据库中获取玩家所有数据
    public String getPlayerData(String playName) {
        String string = null;
        String select = "SELECT * FROM " + table + " WHERE name = '%playerName%'";
        try {
            getSQL().openConnection();
            ResultSet set = getSQL().querySQL(select.replace("%playerName%", playName));
            if (set.next()) {
                String jieshou = set.getString("limit");
                String update = set.getString("date");
                string = update + "#" + jieshou;
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            getSQL().closeConnection();
        }
        return string;
    }

    // 保存玩家在DataAPI中的数据
    public void SaverPlayerData(Player player) {
        if (Main.dataAPI.get(player) == null) {
            return;
        }
        PLimitData dataAPI = Main.dataAPI.get(player);
        String update_time = dataAPI.getUpdata_time();
        String limit = String.valueOf(dataAPI.getLimit());
        String set = "UPDATE `" + table + "` SET " +
                "`limit` = '%limit%'," +
                "`date` = '%date%' WHERE `" + table + "`.`name` = '%player%'";
        getSQL().openConnection();
        getSQL().updateSQL(set.replace("%player%", player.getName()).
                replace("%limit%", limit)
                .replace("%date%", update_time));
        getSQL().closeConnection();
    }
}
